import React, { useContext } from 'react'
import IButtonProps from './IButtonProps'
import { UserContext } from '../../../utils/PrivateRoute'
import { ERoles } from '../../../enums/ERoles'

const Button: React.FunctionComponent<IButtonProps> = (props): React.ReactElement => {
    const role = useContext(UserContext)
    return (
        !props.roles || role && props.roles.includes(role) ? 
            <button onClick={props.click}>{props.title}</button>
        : <></>
    )
}

export default Button