import React, { useEffect } from 'react'
import { shallowEqual, useDispatch, useSelector } from 'react-redux'
import { Navigate, Outlet } from 'react-router-dom'
import { AppDispatch, AppState } from '../store/store'
import { checkToken } from '../store/users/users.slice'


const PermissionRoute: React.FunctionComponent<{roles: string[]}> = ({roles}): React.ReactElement => {
    const {isAuth, user} = useSelector((state: AppState) => state.users, shallowEqual)
    const dispatch: AppDispatch = useDispatch()
    useEffect(() => {
        dispatch(checkToken())
    }, [])
    return (
        isAuth && user?.role && roles.includes(user?.role)
        ? 
            <Outlet />
        :
            <Navigate to='/' replace />
    )
}

export default PermissionRoute